function Initialize()

	msmGmail = SKIN:GetMeasure("mGmail")
	sTimeORDate = SELF:GetOption('TimeORDate')
	sDateFormat = SELF:GetOption('DateFormat')
	
end -- function Initialize

function Update()
		
		sRaw = msmGmail:GetStringValue()
		
		iFullCount = tonumber(string.match(sRaw, ".<fullcount>(.-)</fullcount>"))
		
		-- Errors
		if iFullCount == nil then
		print('Please check your Gmail credentials. The skin couldn\'t connect to Gmail servers.')
		return
		end
		
		ParseFeeds(sRaw)
		CreateData(sRaw)

		 for i = 1, (iFullCount<5 and iFullCount or 4) do
		  -- for i = 1, iFullCount do
			if tTitles[i] then
				SKIN:Bang('!SetOption GmailAuthor'..i..' Text \"'..tAuthors[i]..'\"')
				-- SKIN:Bang('!SetOption GmailContent'..i..' Y 18r')
				SKIN:Bang('!SetOption GmailContent'..i..' Text \"'..tTitles[i]..' - '..tDescs[i]..'\"')
				-- SKIN:Bang('!SetOption GmailTimeDate'..i..' Y 2r')
				if sTimeORDate == 'Date' then
					SKIN:Bang('!SetOption GmailTimeDate'..i..' Text \"'..tDates[i]..'\"')
				elseif sTimeORDate == 'Time' then
					SKIN:Bang('!SetOption GmailTimeDate'..i..' Text \"'..tTimes[i]..'\"')
				end
				SKIN:Bang('!SetOption', 'Button'..i, 'LeftMouseUpAction', '[\"'..tLinks[i]..'\"][!EnableMeasure mClickRefresh]')
			end
		end
		
		SKIN:Bang('!SetOption GmailCount Text '..iFullCount..'')
		
		if iFullCount == 0 then
			SKIN:Bang('!SetOption WhiteBack H 1')
			SKIN:Bang('!SetOption Background H 85')
			SKIN:Bang('!HideMeterGroup MailAll')
		else
			if iFullCount < 5 then	
				SKIN:Bang('!HideMeterGroup MailAll')
				SKIN:Bang('!SetOptionGroup', 'GmailContent', 'Y', '')
				SKIN:Bang('!SetOptionGroup', 'GmailTimeDate', 'Y', '')
				for i=1, iFullCount do
					SKIN:Bang('!SetOption', 'GmailContent'..i, 'Y', '18r')
					SKIN:Bang('!SetOption', 'GmailTimeDate'..i, 'Y', '2r')
					SKIN:Bang('!ShowMeterGroup Mail'..i..'')
					SKIN:Bang('!SetOption WhiteBack H '..(54*i)..'')
					SKIN:Bang('!SetOption', 'Background', 'H', (54*i)+85)
				end
			else
				SKIN:Bang('!SetOptionGroup', 'GmailContent', 'Y', '18r')
				SKIN:Bang('!SetOptionGroup', 'GmailTimeDate', 'Y', '2r')
				SKIN:Bang('!ShowMeterGroup MailAll')
				SKIN:Bang('!SetOption WhiteBack H 216')
				SKIN:Bang('!SetOption', 'Background', 'H', '301')
			end
		end
		
		return "Unread: "..iFullCount

end -- function Update

--========================================
--=========== FEED FUNCTIONS BIBLE =============
-- DO NOT EDIT


function ParseFeeds(sRaw)

	-----------------------------------------------------------------
	-- FEED FORMAT AND CONTENTS
	
		sRawCounted, iNumberOfItems = string.gsub(sRaw, '<entry', "")
		sPatternItemTitle = '.-<title.->(.-)</title>'
		sPatternItemAuthor1 = '.-<source.-</id>.-<title.->(.-)</title>'
		sPatternItemAuthor2 = '.-<author.-<name>(.-)</name>'
		sPatternItem = '<entry.-</entry>'
		sPatternItemDesc1 = '<summary.->.-> (.-)</a>.-</summary>'
		sPatternItemDesc2 = '.-<summary.->(.-)</summary>'
		sPatternItemLink = '.-<link.-href="(.-)"'
		sPatternItemDate1 = '.-<updated.->(.-)</updated>'
		sPatternItemDate2 = '.-<modified.->(.-)</modified>'
		sPatternTime = 'T(.*):'
		sPatternMonth = '-(.-)-'
		sPatternDay = '-.--(.-)T'
		
end

function CreateData(sRaw)

	tTitles = {}
	tAuthors = {}
	tDescs = {}
	tLinks = {}
	tDates = {}
	tTimes = {}


	-----------------------------------------------------------------------
	-- CREATE DATABASE

	iInit = 0
	for i = 1, iNumberOfItems do
		iItemStart, iItemEnd = string.find(sRaw, sPatternItem, iInit)
		sItem = string.sub(sRaw, iItemStart, iItemEnd)
		tTitles[i] = string.match(sItem, sPatternItemTitle)
		tTitles[i] = ParseSpecialCharacters(tTitles[i])
		if string.match(sItem, sPatternItemAuthor1) then
			sPatternItemAuthor = sPatternItemAuthor1
		elseif string.match(sItem, sPatternItemAuthor2) then
			sPatternItemAuthor = sPatternItemAuthor2
		end
		tAuthors[i] = string.match(sItem, sPatternItemAuthor)
		tAuthors[i] = ParseSpecialCharacters(tAuthors[i])			
		if string.match(sItem, sPatternItemDesc1) then
			sPatternItemDesc = sPatternItemDesc1
		elseif string.match(sItem, sPatternItemDesc2) then
			sPatternItemDesc = sPatternItemDesc2
		end
		tDescs[i] = string.match(sItem, sPatternItemDesc)
		tDescs[i] = ParseSpecialCharacters(tDescs[i])
		tLinks[i] = string.match(sItem, sPatternItemLink)
		tLinks[i] = ParseSpecialCharacters(tLinks[i])
		if (string.match(sItem, sPatternItemDate1) or  string.match(sItem, sPatternItemDate2)) then
			if string.match(sItem, sPatternItemDate1) then
				sPatternItemDate = sPatternItemDate1
			elseif string.match(sItem, sPatternItemDate2) then
				sPatternItemDate = sPatternItemDate2
			end
			tDates[i] = string.match(sItem, sPatternItemDate)
			tDates[i] = ParseSpecialCharacters(tDates[i])
			tTimes[i] = string.match(tDates[i], sPatternTime)
			tDates[i] = GoodDate(tDates[i], sDateFormat)
		else
			tDates[i] = ''
		end
		iInit = iItemEnd + 1
	end
	
end

function ParseSpecialCharacters(sString)

	if sString then
		sString = string.gsub(sString, "\"", "'")
		sString = string.gsub(sString, "<!%[CDATA%[", "")
		sString = string.gsub(sString, "%]%]>", "")
		sString = string.gsub(sString, "/PRE&gt;", "")
		sString = string.gsub(sString, "PRE&gt;", "") 
		sString = string.gsub(sString, "&amp;", "&")
		sString = string.gsub(sString, "<p>", "")
		sString = string.gsub(sString, "</p>", "")
		sString = string.gsub(sString, "<em>", "")
		sString = string.gsub(sString, "</em>", "")
		sString = string.gsub(sString, "<strong>", "")
		sString = string.gsub(sString, "</strong>", "")
		sString = string.gsub(sString, "<div.->", "")
		sString = string.gsub(sString, "</div>", "")
		sString = string.gsub(sString, "&quot;", "\'")
		sString = string.gsub(sString, "&#39;", "'")
		sString = string.gsub(sString, "<a title.-</a>", "")
		sString = string.gsub(sString, "&amp;amp;feature=youtube_gdata", "")
	end
	
	return sString
	
end -- function	ParseSpecialCharacters

function GoodDate(sDate, sDateFormat)

	if sDate then
		sDay = string.match(sDate, sPatternDay)
		sMonth = string.match(sDate, sPatternMonth)
		Separator = ' '
		if string.match(sDateFormat, 'Month') then
			sMonth = string.gsub(sMonth, "01", "January")
			sMonth = string.gsub(sMonth, "02", "February")
			sMonth = string.gsub(sMonth, "03", "March")
			sMonth = string.gsub(sMonth, "04", "April")
			sMonth = string.gsub(sMonth, "05", "May")
			sMonth = string.gsub(sMonth, "06", "June")
			sMonth = string.gsub(sMonth, "07", "July")
			sMonth = string.gsub(sMonth, "08", "August")
			sMonth = string.gsub(sMonth, "09", "September")
			sMonth = string.gsub(sMonth, "10", "October")
			sMonth = string.gsub(sMonth, "11", "November")
			sMonth = string.gsub(sMonth, "12", "December")
		elseif string.match(sDateFormat, 'Mon') then
			sMonth = string.gsub(sMonth, "01", "Jan")
			sMonth = string.gsub(sMonth, "02", "Feb")
			sMonth = string.gsub(sMonth, "03", "Mar")
			sMonth = string.gsub(sMonth, "04", "Apr")
			sMonth = string.gsub(sMonth, "05", "May")
			sMonth = string.gsub(sMonth, "06", "Jun")
			sMonth = string.gsub(sMonth, "07", "Jul")
			sMonth = string.gsub(sMonth, "08", "Aug")
			sMonth = string.gsub(sMonth, "09", "Sep")
			sMonth = string.gsub(sMonth, "10", "Oct")
			sMonth = string.gsub(sMonth, "11", "Nov")
			sMonth = string.gsub(sMonth, "12", "Dec")
		elseif string.match(sDateFormat, 'MM') then
			Separator = ' / '
		end
		if string.match(sDateFormat, 'DD/.-') then
			sDate = sDay..Separator..sMonth
		else
			sDate = sMonth..Separator..sDay
		end
	end
	
	return sDate

end --function GoodDate
