function Initialize()

	msmGmail = SKIN:GetMeasure("mGmail")
	
end -- function Initialize

function Update()
		
		sRaw = msmGmail:GetStringValue()
		
		iFullCount = tonumber(string.match(sRaw, ".<fullcount>(.-)</fullcount>"))
		
		-- Errors
		if iFullCount == nil then
		print('Please check your Gmail credentials. The skin couldn\'t connect to Gmail servers.')
		return
		end
		
		ParseFeeds(sRaw)
		CreateData(sRaw)

		ToolTipText = ""
		 for i = 1, (iNumberOfItems < 6 and iNumberOfItems or 5) do
			if tTitles[i] then 
				ToolTipText =(i == 1 and "" or ToolTipText..'#CRLF#')..tAuthors[i]..' - '..tTitles[i]
			end
		end
		
		if iFullCount > 0 then
			-- SKIN:Bang('!SetOption', 'Gmail', 'ImageName', 'GmailFull.png')
			SKIN:Bang('!SetOption', 'Count', 'ToolTipText', ToolTipText)
		else
			SKIN:Bang('!SetOption', 'Count', 'ToolTipText', 'No New Mails.')
			-- SKIN:Bang('!SetOption', 'Gmail', 'ImageName', 'GmailEmpty.png')
		end
	
		return iFullCount

end -- function Update

--========================================
--=========== FEED FUNCTIONS BIBLE =============
-- DO NOT EDIT


function ParseFeeds(sRaw)

	-----------------------------------------------------------------
	-- FEED FORMAT AND CONTENTS
	
		sRawCounted, iNumberOfItems = string.gsub(sRaw, '<entry', "")
		sPatternItemTitle = '.-<title.->(.-)</title>'
		sPatternItemAuthor1 = '.-<source.-</id>.-<title.->(.-)</title>'
		sPatternItemAuthor2 = '.-<author.-<name>(.-)</name>'
		sPatternItem = '<entry.-</entry>'
		sPatternItemDesc1 = '<summary.->.-> (.-)</a>.-</summary>'
		sPatternItemDesc2 = '.-<summary.->(.-)</summary>'
		sPatternItemLink = '.-<link.-href="(.-)"'
		sPatternItemDate1 = '.-<updated.->(.-)</updated>'
		sPatternItemDate2 = '.-<modified.->(.-)</modified>'
		sPatternTime = 'T(.*):'
		sPatternMonth = '-(.-)-'
		sPatternDay = '-.--(.-)T'
		
end

function CreateData(sRaw)

	tTitles = {}
	tAuthors = {}

	-----------------------------------------------------------------------
	-- CREATE DATABASE

	iInit = 0
	for i = 1, iNumberOfItems do
		iItemStart, iItemEnd = string.find(sRaw, sPatternItem, iInit)
		sItem = string.sub(sRaw, iItemStart, iItemEnd)
		tTitles[i] = string.match(sItem, sPatternItemTitle)
		tTitles[i] = ParseSpecialCharacters(tTitles[i])
		if string.match(sItem, sPatternItemAuthor1) then
			sPatternItemAuthor = sPatternItemAuthor1
		elseif string.match(sItem, sPatternItemAuthor2) then
			sPatternItemAuthor = sPatternItemAuthor2
		end
		tAuthors[i] = string.match(sItem, sPatternItemAuthor)
		tAuthors[i] = ParseSpecialCharacters(tAuthors[i])			
		iInit = iItemEnd + 1
	end
	
end

function ParseSpecialCharacters(sString)

	if sString then
		sString = string.gsub(sString, "\"", "'")
		sString = string.gsub(sString, "<!%[CDATA%[", "")
		sString = string.gsub(sString, "%]%]>", "")
		sString = string.gsub(sString, "/PRE&gt;", "")
		sString = string.gsub(sString, "PRE&gt;", "") 
		sString = string.gsub(sString, "&amp;", "&")
		sString = string.gsub(sString, "<p>", "")
		sString = string.gsub(sString, "</p>", "")
		sString = string.gsub(sString, "<em>", "")
		sString = string.gsub(sString, "</em>", "")
		sString = string.gsub(sString, "<strong>", "")
		sString = string.gsub(sString, "</strong>", "")
		sString = string.gsub(sString, "<div.->", "")
		sString = string.gsub(sString, "</div>", "")
		sString = string.gsub(sString, "&quot;", "\'")
		sString = string.gsub(sString, "&#39;", "'")
		sString = string.gsub(sString, "<a title.-</a>", "")
		sString = string.gsub(sString, "&amp;amp;feature=youtube_gdata", "")
	end
	
	return sString

end
